###############################################################################################
##																							 ##
##   R Code for performing simulations for scenarios 1 and 2 in the paper					 ##
## "How much are we missing in SNP-by-SNP analyses of GWAS?" M Shi, CR Weinberg Epidemiology ##
##	2011																						 ##
###############################################################################################
run.sim <- function(snp.num,hap.num, hap.goal,freq.hap1,hap.type,risk.hap.dis,risk.hap.dis.e,
e.fr,  freq.hap2, risk.hap.dis2,risk.hap.dis.e2, e.fr2,pop1.fr, n.fam,iter)
{
	freq.hap <- freq.hap1
	for (i in 1:iter) {
		total.n <- 0
		n.loci <- 3
		snp.ct <-rep(0,n.loci*2)
		count.fam=1
		pedigree<-NULL
		all.fam.delta<-NULL
		pop.vec<-NULL
		env0.vec <- NULL
		while (count.fam<=n.fam)
		{
# This while loop is used to create disease status only affected families
# will be retained.
			if (count.fam ==1) .append <- FALSE else .append <- TRUE
			aff <-0
			while ( ! aff)
			{
				total.n <- total.n+1
				pop <-sample(c(1,2),1,prob=c(pop1.fr,1-pop1.fr),replace=T)
				if (pop==1) {e.fr.sel<-e.fr; freq.hap.sel<-freq.hap} else {
					e.fr.sel<-e.fr2;freq.hap.sel<-freq.hap2}
				
				env <-sample(c(0,1),1,prob=c(1-e.fr.sel,e.fr.sel),replace=T)
				env0 <-sample(c(0,1),1,prob=c(1-e.fr.sel,e.fr.sel),replace=T)
				if (env ==1 & pop==1) risk.dis<-risk.hap.dis.e
				if (env ==1 & pop==2) risk.dis<-risk.hap.dis.e2
				if (env ==0 & pop==1) risk.dis<-risk.hap.dis
				if (env ==0 & pop==2) risk.dis<-risk.hap.dis2
				geno.f <- NULL
				geno.m <- NULL
				geno.kid <- NULL
				geno.kid2 <- NULL
				for (k in 1:(2*n.loci)){
					hap.f1 <- sample(1:hap.num, 1, prob=freq.hap.sel, replace=T)
					hap.f2 <- sample(1:hap.num, 1, prob=freq.hap.sel, replace=T)
					geno.f <- c(geno.f, hap.type[2:(snp.num+1),hap.f1]+hap.type[2:(snp.num+1),hap.f2]-2)
					
					hap.m1 <- sample(1:hap.num, 1, prob=freq.hap.sel, replace=T)
					hap.m2 <- sample(1:hap.num, 1, prob=freq.hap.sel, replace=T)
					geno.m <- c(geno.m, hap.type[2:(snp.num+1),hap.m1]+ hap.type[2:(snp.num+1),hap.m2] -2)
					
					hap.fro.f <-sample(c(hap.f1,hap.f2),1,prob=c(0.5,0.5),replace=T)
					hap.fro.m <-sample(c(hap.m1,hap.m2),1,prob=c(0.5,0.5),replace=T)
					geno.kid <- c(geno.kid, hap.type[2:(snp.num+1),hap.fro.f]+hap.type[2:(snp.num+1),hap.fro.m] -2)
					
					hap.fro.f <-sample(c(hap.f1,hap.f2),1,prob=c(0.5,0.5),replace=T)
					hap.fro.m <-sample(c(hap.m1,hap.m2),1,prob=c(0.5,0.5),replace=T)
					geno.kid2 <- c(geno.kid2, hap.type[2:(snp.num+1),hap.fro.f]+hap.type[2:(snp.num+1),hap.fro.m] -2)
					if (geno.kid[k]>0) snp.ct[k]<-snp.ct[k]+1
				}
				risk.kid<-1
				if (sum(geno.kid[1:n.loci]>0)==n.loci|sum(geno.kid[(n.loci+1):(2*n.loci)]>0)==n.loci) risk.kid<-risk.kid+1
				aff<-sample(c(1,0),1,prob=c(risk.dis[risk.kid],(1-risk.dis[risk.kid])),replace=T)
				risk.kid<-1
				if (sum(geno.kid2[1:n.loci]>0)==n.loci|sum(geno.kid2[(n.loci+1):(2*n.loci)]>0)==n.loci) risk.kid<-risk.kid+1
				aff2<-sample(c(1,0),1,prob=c(risk.dis[risk.kid],(1-risk.dis[risk.kid])),replace=T)
				family.kid <- c(count.fam, 1, geno.kid)
				family.kid2 <- c(count.fam, aff2, geno.kid2)
				family.father <- c(count.fam, 0,  geno.f)
				family.mother <- c(count.fam, 0,  geno.m)      
			}
			family<-rbind(family.father,family.mother,family.kid,family.kid2)
			count.fam<-count.fam+1
			write(t(family),ncol=dim(family)[2],file='cleft.ped',append=.append)
			cat('total.n:',total.n,'snp.ct',snp.ct,'\n')
			
        }
    }
	paste('total.n:',total.n,'snp.ct',paste(snp.ct,collapse=' '))->rst
	write(rst,file='total.n')
	read.table('cleft.ped')->ped
	read.table('total.n',as.is=T)->counts
	n.case <- dim(ped)[1]/4
	total.n <- counts[1,2]
	risk.kid2 <- sum(ped[,2])/dim(ped)[1]*4 -1
	pop.risk <- dim(ped)[1]/4/total.n
	n.set <-2
	n.loci <- (dim(ped)[2]-2)/2/n.set
	mut1 <- ped[seq(3,dim(ped)[1],4),seq(3,2+n.loci*2,by=2)]
	mut2 <- ped[seq(3,dim(ped)[1],4),seq(3+n.loci*2,2+n.loci*4,by=2)]
	mak1 <- ped[seq(3,dim(ped)[1],4),seq(4,2+n.loci*2,by=2)]
	mak2 <- ped[seq(3,dim(ped)[1],4),seq(4+n.loci*2,2+n.loci*4,by=2)]
	n.set.case <-sum(apply(mut1>0,1,sum)==n.loci)
	n.set0.case <- n.case-n.set.case
	n.snp.case <- sum(mut1[,1]>0)
	n.snp0.case <- n.case-n.snp.case
	n.snp.ctrl <- counts[1,4] - n.snp.case
	n.snp0.ctrl <- total.n-n.case-n.snp.ctrl
	set.rr <- (total.n-n.case+n.set0.case)/n.set0.case
	snp.rr <- n.snp.case/(n.snp.case+n.snp.ctrl)/n.snp0.case*(n.snp0.case+n.snp0.ctrl)
	cat(' poplation prevalence:',pop.risk,'\n sib recurrence relative risk:',risk.kid2/pop.risk,
		'\n relative risk of the multi-locus genotype set:',set.rr,'\n relative risk of a single SNP in the set:',snp.rr,'\n')
	
}


####################################################################################
# This is the loop to ger simulation pedigree files, each trio will be output in a #
# single line. Iter defines the number of files generated, and n.fam determines    #
# the number of trios in each file.                                                #
####################################################################################

  simu.risk<-function(hap.goal,hap.risk,hap.risk.e,e.fr,e.fr2,hap.fr1,hap.fr2,pop1.fr,disease.ratio)
  # hap.risk: risk of each genotype without exposure
  # hap.risk.e: risk of each genotype with exposure
  # disease.ratio: the ratio of background disease rates in the two pops
  # frequency of the risk hapltotype in the populations: hap.fr1 & hap.fr2
  {
	  
	  freq.hap0<- c(1/3,2/3)
	  
	  snp.num<-1
	  hap.num<-2
	  
	  hap.type<- matrix(
						c(1,2,
						  1,2),
						nrow=snp.num+1,byrow=T)
	  
	  
  freq.dis<-1/hap.risk[3]
  risk.hap.dis<-hap.risk*freq.dis
  risk.hap.dis.e<-hap.risk.e*freq.dis
  risk.hap.dis2<-hap.risk*freq.dis/disease.ratio
  risk.hap.dis.e2<-hap.risk.e*freq.dis/disease.ratio

 #change risk hap fr and rewieght the rest haps
  freq.hap1<-freq.hap0
  freq.hap2<-freq.hap0

  freq.hap1[-hap.goal] <-freq.hap0[-hap.goal]/sum(freq.hap0[-hap.goal])*(1-hap.fr1)
  freq.hap1[hap.goal]<-hap.fr1

  freq.hap2[-hap.goal] <-freq.hap0[-hap.goal]/sum(freq.hap0[-hap.goal])*(1-hap.fr2)
  freq.hap2[hap.goal]<-hap.fr2
 run.sim(snp.num,(hap.num), hap.goal,freq.hap1,hap.type,risk.hap.dis,risk.hap.dis.e,e.fr,
          freq.hap2, risk.hap.dis2,risk.hap.dis.e2, e.fr2,pop1.fr,n.fam,1)

 }
 ############################################################################

n.fam<-10000     # Number of families * THIS IS A PARAMTER TO BE CHANGED BY USER* 
M<- 1500      # Relative risk of high-risk sufficient multi-locus genotype in the exposed group  * THIS IS A PARAMTER TO BE CHANGED BY USER* 
fr <- 0.078   # Frequency of high-risk sufficient multi-locus genotype * THIS IS A PARAMTER TO BE CHANGED BY USER* 
r.e <-1      #  Relative risk of the exposure (smoking) 
i1<-1          #  Relative risk of gene-by-environment interaction for 1 copy of the multi-locus genotype  
i2<-1          #  Relative risk of gene-by-environment interaction for 2 copies of the multi-locus genotype 

r1 <-M       # Relative risk of carrying 1 copy of the multi-locus genotype
r2 <- M      # Relative risk of carrying 2 copies of the multi-locus genotype


simu.risk(hap.goal=2,hap.risk=c(1,r1,r2),hap.risk.e=c(r.e,r.e*r1*i1,r.e*r2*i2),e.fr=0.3,e.fr2=0.3,hap.fr1=fr,hap.fr2=fr,pop1.fr=0.5,
          disease.ratio=1)

